<?php

// ===================================================================
// Global configuration parameters:

// global $backgroundmode,$defaultzone;

//  configure script as background process job
//  leave cpu time
//  value :=  # seconds  to sleep every # of processed lines
define('_backgroundmode',1);

// define default zone
define('_DEFAULTZONE','2');

// Nodelist Data Directory if not actual script directory
// 
// $ndldir = "Q:/SERVICE/0_ARCHIV/pub/fidohist/nodelist";
// see NLSOURCE in includes/config.php

define('undef','');

//  Forced Re-Import
//  re-import imported nodelists
define('_FORCED',True);

// ===================================================================

// #!i:/apache/perl/bin
// package nlimport;
// use strict;
// use warnings;

/************************************************************************/
/* NDL2DB.PHP                                                           */
/* ====================                                                 */
/* Program to import nodelist data into MySQL 5 database                */
/*                                                                      */
/* NDL2DB.PHP is the PHP port of the previous                           */
/* NLIMPORT.PL script v1.0                                              */
/* Copyright (c) 2007 by Alex Woick Wombaz                              */
/*                                                                      */
/* NDL2DB.PHP                                                           */
/* Copyright (c) 2007 by Ulrich Schroeter                               */
/* http://ambrosia60.dnsalias.net                                       */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/


$versionno = "2.10";
$releasedate = "16.08.2011";
$version1 = "ndl2db.php version ".$versionno." - ".$releasedate.",";
$version2 = "the php port of the nlimport.pl";
$copyright_notice1 = "nlimport.pl Copyright (c) 2007 by Alex Woick @ Wombaz";
$copyright_notice2 = "ndl2db.php port Copyright (C) 2007,2008 by Ulrich Schroeter @ ambrosia60";
$copyright_notice3 = "This is free software, and you may redistribute it under the GPL.";



/*
#
# Change History
#
#   28 Apr 2010 - v2.03 Release Candidate 1
#     php5 compatibility (by Kees van Eeten)
#
#   30 Nov 2007 - v1.0 (PHP)
#     Port to PHP
#
#   22 Feb 2007
#     Suggestion by Alex Woick of DB structure
#     with a PL script for import nodelist data
 */


global $rmarg,$sid;

$sid   = 0;            //  global session-id
$rmarg = 0;            // default directory scan and execution
$debut = time();

// set auto_detect_line_endings = ON in php.ini !!!

set_time_limit(0); //  0=forever   (24*60*60); // 1 day ... should be enough  ;-)
$date = date("YmdHis",time());
$progress = 1;
$no_connect = 0;
$perrn = 0;
$perrt = "";
$crlf = chr(13).chr(10);

// regexp validation string for dnsnames incl. ip addresses
// $rstrdnsname = "/^[a-z0-9\-]+\.([a-z0-9\-]+\.){0,}?[a-z]{2,6}$/i";
$rstrdnsname = "/((^[a-z0-9\-]+\.([a-z0-9\-]+\.){0,}?[a-z]{2,6}$)|(^(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$))/i";


// define("undef",false);
$undef = false;

if (!isset($REMOTE_ADDR) && !isset($_SERVER['REMOTE_ADDR'])) {
  // register_argc_argv should be set to on: if you cannot turn this option on,
  // uncommenting the next two lines. if you then get an undefine index message
  // recomment these same two lines. Also see http://www.php.net/reserved.varia
  $argc = $_SERVER["argc"];
  $argv = $_SERVER["argv"];
  $br = "\n";
  $hr = "\n-----------------------------\n";
  $run_mode = 'cgi';
  $s_yes = "+";
  $s_no  = "X";
  $s_link = "@url";
  if ($argc > 1) {
    // what runmode was launched ?
    switch($argv[1]) {
      case '0':
        // working on workqueue
        $rmarg = 0;
        break;

      case '1':
        //   regular directory scan
        $rmarg = 1;
        break;

      case '2':
        // search possible nodelists and write path and filenames to workqueue, sord=99999
        $rmarg = 2;
        break;

      case '3':        
        // ndl2db 3 path/file
        // add path/file to workqueue
        $rmarg = 3;
        $raddndl = addslashes($argv[2]);
        break;

      case '4':        
        // ndl2db 4 path/file
        // import single path/file w/o workqueue
        $rmarg = 4;
        $raddndl = addslashes($argv[2]);
        break;

      default:
        // working on workqueue
        $rmarg = 0;
        break;
    }
  } else {
    // working on workqueue
    $rmarg = 0;
  }
}

// =============================================================================
//  subfunctions begin section



function ndlsearch($pdir='') {
   // $sf
   global $ndldir;
   // nodelist.* => regexp: /^nodelist\.\d$/
   $rstr = "/^nodelist\.\d{3}$/i";
   $br = "\r\n";
   $onefound = false;
   $ndldays = array(
     "Monday",
     "Tuesday",
     "Wednesday",
     "Thursday",
     "Friday",
     "Saturday",
     "Sunday"
   );

   // $blockslist = array();
   $actfile = "";
   $cmpfile = chr(254);
   if (($ndldir!="") and ($pdir!="")) {
      if ($pdir!="") {
        $mxpath = $pdir;
      } else {
        $mxpath = $ndldir;
      }
   } else {
      $mxpath = getcwd();
   }
   // echo $mxpath.$br;
   
   $actpath = $mxpath."\\";
   $blocksdir = dir($mxpath);
   while($func=$blocksdir->read()) {
     $file = strtoupper($func);
     if (($func!=".") and ($func!="..") and is_dir($actpath.$func)) {
        // is directory entry, skip
        if (($func!=".") and ($func!=".."))  {
          // call recursive until all subdirs are handled
          ndlsearch($actpath.$func);
        }
     } else {
        if (($func!=".") and ($func!="..")) {
           if (preg_match($rstr,$file)) {
             // file_get_contents -- Reads entire file into a string
             $input = file($actpath.$func);
             //print "Path: ".$actpath." File: ".$func.$br;
             // print "File: ".$func." Filesize: ".$fbbssize.$br;
             // print "1st line:".$br.$input[0].$br;
             if (substr($input[0],0,2)==";A") {
                $onefound = true;
                // is ndl file
                // print "Path: ".$actpath." File: ".$func.$br;
                // extract ndl date, NOT filedate!!!
                // get date out of admin line
                // extract string between  "for workday," and " -- Day number"
                $stop = false;
                $k = 0;
                while ((!$stop) && ($k<7)) {
                   if (at(" for ".$ndldays[$k].",",$input[0])>0) {
                      $stop = true;
                   } else {
                      $k++;
                   }
                }
                $startpos1 = at(" for ".$ndldays[$k].",",$input[0]);
                $endpos    = at(" -- Day number",$input[0]);
                $sdaylen   = strlen($ndldays[$k]);
                $linepart1 = substr($input[0],$startpos1+7+$sdaylen,$endpos-$startpos1-7-$sdaylen);
                //echo $startpos1.", ".$endpos.$br;
                //echo "[".$linepart1."]".$br;

                $uts = strtotime($linepart1);
                $ndldate = date('Ymd',$uts);
                //echo "Unix timestamp: ".$uts.$br;
                //echo "converted ....: ".$ndldate.$br;

              $actfile = $ndldate.$func;
                if ($cmpfile==chr(254)) { $cmpfile = $actfile; }
                if ($actfile > $cmpfile) {
                   $cmpfile = $actfile;
                }
             //} else {
               // skip, not a nodelist file
             }
           }
        }
     }
   }
	 closedir($blocksdir->handle);
   // name of file is crypted:  ndldate + nodelist-filename
   //  20070330nodelist.999
   // echo "Actual nodelist: ".substr($cmpfile,8).$br;

   if ($onefound) {
      return substr($cmpfile,8);
   } else {
      return false;
   }
}


function inspectfmt($ndlpthfile) {
  global $db,$shortfnameL,$shortfnameU,$short2L,$short2U,$m_id_nl_type,$m_id_nl_frmt;

  // $resultA = $db->sql_query("select config_name, config_value from ".$prefix."_downloads_dlicfg where config_name='PREVENT1'");
  // while ($rowA = $db->sql_fetchrow($resultA)) {
  //    $cfgname  = $rowA['config_name'];
  //    $cfgval   = intval($rowA['config_value']);
  $foundC = 0;
  $query1 = "select id_nl_type,id_nl_frmt,ndl_mask from nl_type where ndl_mask='".$short2U."'";
  // echo $short2U."\r\n";
  $result1 = $db->sql_query($query1);
  while ($row1 = $db->sql_fetchrow($result1)) {
    $m_id_nl_type = intval($row1['id_nl_type']);
    $m_id_nl_frmt = intval($row1['id_nl_frmt']);
    $foundC++;
  }
  $db->sql_freeresult($result1);
  // echo $query1."\r\n".$found2."\r\n";
  if ($foundC > 0) {
    if ($foundC > 1) {
      // multiple entries found, needs further inspection (i.e. Z2PNT Boss or Poss)
    
    }
    switch ($m_id_nl_frmt) {
      case "1":
        // (1,'St.Louis Nodelist')
        if (!defined('_NFMT1')) {
          include("includes/func_nf1.php");            
        }
        nfmt1($ndlpthfile);
        break;

      case "2":
        // (2,'Boss Pointlist')
        break;

      case "3":
        // (3,'Poss Pointlist')
        break;

      case "4":
        // (4,'Point/V7 Pointlist')
        break;

      case "5":
        // (5,'Fakenet Pointlist')
        break;

      case "6":
        // (6,'Fakenet R24 Old Pointlist')
        break;

      case "7":
        // (7,'Fakenet R23 Pointlist')
        break;

      case "8":
        // (8,'Fidouser Pointlist')
        break;
        
    }
  } else {
    // not found            
    // no valid nodelist type
    logfile('D', "No valid nodelist type found: '".$shortfnameL."'");
    return False;
  }
  return True;
}

function import_if_nodelist($ndlpthfile) {
  global $db,$shortfnameL,$shortfnameU,$short2L,$short2U;
  // ,$fcontent;
  global $ndlyear,$ndldnr,$ndlcrc;  
  
  $shortfnameL = strtolower(basename($ndlpthfile));
  $shortfnameU = strtoupper($shortfnameL);
  $short2L = strtolower(basename($ndlpthfile,substr($shortfnameL,at(".",$shortfnameL ) )));
  $short2U = strtoupper($short2L);

  $rval = True;
  
  logfile('D', "check if nodelist: '".$ndlpthfile."'");
  // # detect and identify nodelist or pointlist file
  // # ;A FidoNet Nodelist for Friday, July 6, 1990 -- Day number 187 : 30661
  // # detect nodelist file
  // # ;A FidoNet Nodelist for Friday, July 6, 1990 -- Day number 187 : 30661
  //open(my $file, '<', $fname) or return 0;
  //binmode($file);
  //my $line1 = <$file>;
  //$line1 =~ s/\015\012$//;
  //if (my ($year, $daynr, $crc) = $line1 =~ /^;A .* for .* (\d\d\d\d) -- Day number (\d+) : (\d+)/i) {
  //  my $startpos = tell($file);
  //  
  //  # this might be a nodelist or a nodediff. Look at the next line.
  //  return if <$file> =~ /^[ADC][\d]+/;
  //  seek($file, $startpos, 0);
  //  Log::log('D', "found $shortfname: year=$year, daynr=$daynr, crc=$crc");
  //  # check crc
  
  //if (isset($fcontent)) {
  //  unset($GLOBALS['fcontent']);
  //  $fcontent = array();
  //}
  
  $fcontent = file($ndlpthfile);
  $line1 = rtrim($fcontent[0]);

  // identify Nodelist and/or Pointlist and/or Pointlist type
  // some pointlists includes also CRCs for validation
  // search nl_type for filename mask, get nl_frmt

  // if Z2PNT addtl. Test POSS or BOSS

  // logfile('D', "Debug: strlen line 1 ....: '".(strlen($line1))."'");  // w/ line endings
  // logfile('D', "Debug: strlen trim line 1: '".(strlen(rtrim($line1)))."'");  // w/o line endings
  // ($year, $daynr, $crc)
  if ((preg_match("/^;A .* for .* (\d\d\d\d) -- Day number (\d+) : (\d+)/i",$line1,$sres1)) || (preg_match("/^;A .* (\d\d\d\d) -- Day number (\d+) : (\d+)/i",$line1,$sres1))) {
    // old version
    //  ???  ;A Friday, October 3, 1986 -- Day number 276 : 20179

    //  # this might be a nodelist or a nodediff. Look at the next line.
    //  return if <$file> =~ /^[ADC][\d]+/;
    $line2 = rtrim($fcontent[1]);
    if (preg_match("/^[ADC][\d]+/",$line2,$sres2)) {
      logfile('D', "Identified as Nodediff.");
      return False;
    } else {
      $ndlyear = $sres1[1];
      $ndldnr  = $sres1[2];
      $ndlcrc  = $sres1[3];
      if (($ndlyear<"1987") || (($ndlyear=="1987") && ($ndldnr<"219")))  { 
        logfile('D', "Debug: (Old) Nodelist Year: '".($sres1[1])."'");
      } else {
        logfile('D', "Debug: Nodelist Year .....: '".($sres1[1])."'");
      }
      logfile('D',   "Debug: Nodelist Daynumber : '".($sres1[2])."'");
      logfile('D',   "Debug: Nodelist CRC ......: '".($sres1[3])."'");
      $cndllines = count($fcontent);
      $fcrc = 0x0000;
      //$min = 9999;
      //$max = 0;
      for ($i=1;$i<=$cndllines;$i++) {
        //if ($i < $min) {
        //  $min = $i;
        //}
        //if ($i > $max) {
        //  $max = $i;
        //}
        // EOF ^Z 0x1a  26d
        if (isset($fcontent[$i])) {
          if (($fcontent[$i]!=chr(26)) && ($fcontent[$i]!="")) {
            // $fcrc = crc16c($fcontent[$i],$fcrc);
            $fcrc = crc16dtp($fcrc,$fcontent[$i],strlen($fcontent[$i]));
          }
        }
      }
      logfile('D', "Debug: calculated CRC ...: '".substr("00000".$fcrc,strlen($fcrc),5)."'");
      // logfile('D', "Debug: total/min/max.......: '".$cndllines."/".$min."/".$max."'");
      if (substr("00000".$fcrc,strlen($fcrc),5)!=substr("00000".$sres1[3],strlen($sres1[3]),5)) {
        $lln = "WARNING! CRC mismatch in Nodelist ".$sres1[2]."/".$sres1[1].": '".$sres1[3]."' <> calculated '".$fcrc."'";
        logfile('L', $lln);
        logfile('D', $lln);    
        logfile('E', $lln);    
        return False;
      }
      $rval = inspectfmt($ndlpthfile);
    }
  } else {
    // w/o admin line   i.e. pointlists  use as is
    $rval = inspectfmt($ndlpthfile);                
  }
  return $rval;
}

function import_file($sf) {
  global $dsponce,$pck,$tmp2dir,$sourcefile;
  global $stopflagfileg, $stopflagfiles;
  $sourcefile = $sf;
  if (file_exists($sourcefile)) {
    logfile('D', "import_file: process '".$sourcefile."'");
    $tfp = fopen($sourcefile,"rb");
    $input = fread($tfp,7);
    fclose ($tfp);
    // test archivers
    // $this->directives

    // $test = Configurator::open('/usr/local/apache2/conf/httpd.conf');
    // $test->parse();
    // print_r($test->getDirectives());              
    // print_r($compresscfg->getDirectives());

    // $dsponce = 1;
    
    // $pck = parseToArray();
    // print_r($pck);
  
  
    $pt = packeridentifier($input);
    if ($pt) {
      // archive found: extract it
      // echo "Packer identified: ".$pt.", extract: ".$pck[$pt]['Extract']."\r\n";
      unpackndl2tmp($sourcefile,$pt);
      # extract success
      # process each extracted file
      // for my $fn (glob(File::Spec->catfile($tmpdir, '*'))) {
      // if (-s $fn) {
      $tmp3dir = trailslash($tmp2dir);
      $btmp3dir = dir($tmp3dir);
      while($fil3=$btmp3dir->read()) {
        // echo $sourcepath.$func."\r\n";
        if (strtoupper($fil3)<>".") {
          if (strtoupper($fil3)<>"..") {
            if (strtoupper($fil3)<>"FILES.BBS") {
              // $sourcefile = $sourcepath.$func;
              logfile('D', "import_file: extracted '".$tmp3dir.$fil3."'");
              import_if_nodelist($tmp3dir.$fil3);
              unlink($tmp3dir.$fil3);
            }
          }
        }
      }
      cleantmpdir();
    } else {
      // no archive. process directly
      logfile('D', "import_file: unable to identify '".$sourcefile."'");
      import_if_nodelist($sourcefile);
    }
  
    // debug mode, display only one archive
    // closedir($blocksdir->handle);
    // return True;

  } else {
    // error: file unaccessable
  } 
  return True;
}


// # recursively look into subdirs and import all what looks like a valid FTS-0005
// # nodelist. Detect uncompressed, zipped, 7zipped.
function import_subdir($sourcepath="") {
  global $pck,$tmp2dir,$sourcefile;
  global $stopflagfileg, $stopflagfiles;  
  // $sourcepath;
  if ($sourcepath!="") {
    $sourcepath = trailslash($sourcepath);
  } else {
    $sourcepath = chr(47);
  }

  $blockslist = array();
  $blocksdir = dir($sourcepath);
  $flagstop = False;
  while (!$flagstop) {
    if ($func=$blocksdir->read()) {
      $blockslist .= "$func ";
      if (strtoupper($func)<>".") {
        if (strtoupper($func)<>"..") {
          if (strtoupper($func)<>"FILES.BBS") {
            echo $sourcepath.$func."\r\n";          
            if (is_dir($sourcepath.$func)) {
              // name is a subdir
              // recursivly handle paths
              import_subdir($sourcepath.$func);
              //if ($dsponce!=0) {
              //    closedir($blocksdir->handle);
              //    return True;
              //}              
            } else {
              //  no path, is file
              //      $input = file_get_contents($areapath.$func);
              //      $fbbs = $input;
              $sourcefile = $sourcepath.$func;
              import_file($sourcefile);
            }
          }
        }
      }
      if ( (file_exists($stopflagfileg)) || (file_exists($stopflagfiles)) ) {        
        $flagstop = True;
      }
    } else {
      $flagstop = True;
    }
  }  
  closedir($blocksdir->handle);
  // $blockslist = explode(" ", $blockslist);
                 

  //# I was given a file: import it
  //if (-s $source) {
  //  import_file($source);
  //  return;
  //}
  //return unless -d $source;
  
  //# I was given a directory: scan it
  //for (glob(File::Spec->catfile($source, '*'))) {
  //  import_subdir($_) unless /^\./;
  //}
  return True;
}

// # recursively look into subdirs and import all what looks like a valid FTS-0005
// # nodelist. Detect uncompressed, zipped, 7zipped.
function import_from_wq() {
  global $dsponce,$pck,$tmp2dir,$sourcefile;
  global $db;
  global $rmarg,$sourcefile;
  global $stopflagfileg, $stopflagfiles; 
  $flagstop = False;  

  $foundC = 0;
  $queryw1 = "SELECT * FROM nl_wqueue where state=0 order by sord,year,day";

  while (!$flagstop) {
    $resultw1 = $db->sql_query($queryw1);
    if ($db->sql_numrows($resultw1)>0) {
      $roww1 = $db->sql_fetchrow($resultw1);

      $m_id_wq = intval($roww1['id_wq']);
      $m_sord  = intval($roww1['sord']);
      $m_state = intval($roww1['state']);      
      $m_ndlpf = $roww1['ndlpf'];
      $m_year  = $roww1['year'];
      $m_day   = $roww1['day'];
      $db->sql_freeresult($resultw1);      
      // flag record on work
      if ($db->sql_query("update nl_wqueue set state=1 where id_wq='".$m_id_wq."' AND state=0")) {
        if ($db->sql_affectedrows()>0) {
          // execute import
          import_file($m_ndlpf);
          // delete record from list
          $delete_rec_sql = "DELETE FROM nl_wqueue WHERE id_wq='".$m_id_wq."'";
          if ( !$db->sql_query($delete_rec_sql, BEGIN_TRANSACTION) ) {
            logfile('D', "delete record from wqueue failed: '".$m_id_wq."'");        
            logfile('E', "delete record from wqueue failed: '".$m_id_wq."'");        
          }
        } else {
          //   was, wenn state bereits auf 1?
          //   update laeuft sauber durch, bemerkt aber nicht, dass 0 records geaendert wurden ...
          //   dieser task ist der meinung, state wurde geaendert und laeuft in conflict
          //   zu 1tem task .....
          // skip to next
        }        
      } else {
        // update failed
          logfile('D', "change state record wqueue failed: '".$m_id_wq."'");        
          logfile('E', "change state record wqueue failed: '".$m_id_wq."'");        
      }
      // if stopflag 
      if ( (file_exists($stopflagfileg)) || (file_exists($stopflagfiles)) ) {      
        $flagstop = True;
      }
    } else {
      $flagstop = True;
    }    
  }
  return True;
}

# add nodelist to workqueue
function add_to_wq($sourcefile) {
  global $db;
  $queryw1 = "SELECT * FROM nl_wqueue where ndlpf=".strtoupper($sourcefile);
  $resultw1 = $db->sql_query($queryw1);
  if ($db->sql_numrows($resultw1)>0) {
    // file exists in queue, skip
    logfile('L',"Allways in Workqueue: ".$sourcefile);    
    logfile('D',"Allways in Workqueue: ".$sourcefile);
  } else {
    // does file exist in db ?   checked in func_nf1  nfmt1()
    import_file($sourcefile);
  }  
  return True;
}



//  subfunctions end section
// =============================================================================


// use DBI;
// use File::Temp qw(tempfile tempdir);
// use Time::Local qw(timelocal_nocheck);
// use Digest::CRC qw(crc crc32);

// use cf;  // config (config::read)
// use Log;

//  cf::read($^O eq 'MSWin32' ? 'nlimport_win.conf' : 'nlimport.conf', {
//           LOGFILE => 'nlimport.log',
//           LOGFILE_DEBUG => 'nlimport_debug.log',
//  } );
//  replaced by config.php
// ===================================================================

$actpath = str_replace(chr(92),chr(47),getcwd());
$logfile = $actpath."/nlimport.log";
$logfile_debug = $actpath."/nlimport_debug.log";
$logfile_error = $actpath."/nlimport.err";


$tmpFdir = $actpath."/flag";

@require_once("includes/func_lib.php");
// @require_once("includes/func_dli.php");
include("includes/constants.php");
if (defined('PROG')) {
  /* ok */
} else {
  die("include error: constants undefined.");
}


if (is_dir($tmpFdir)) {
  // use existing path?
} else {
  mkdir($tmpFdir, 0700);
  if (is_dir($tmpFdir)) {
    // ok
  } else {
    logfile("E","Flsgdir ".$tmpFdir." couldn't be created.");
    die("Flag dir couldn't be created.");
  }
}

$stopflagfileg  = $actpath."/flag/session.end";
$sessionflags   = $actpath."/flag/";




// echo "debug 4\r\n";
    
global $prefix, $db, $admin_file;
global $stopflagfileg, $stopflagfiles, $sessionflags, $sessionfile;
// session handling
$lstop = False;
$i = 0;
while (!$lstop) {
  $sessionfile = $sessionflags."session".$i;
  if (!file_exists($sessionfile.".run")) {
    $tsfp = fopen($sessionfile.".run","a+");
    // fclose ($tsfp);
    $stopflagfiles = $sessionfile.".end";
    $lstop = True;
    $sid = $i;
  } else {
    $i++;
  }
}

logfile('D',"Sessionfile: ".$sessionfile.".run");

//  caching
global $hnodes,$hlinecache,$pck;
// 
$hnodes     = array();
$hlinecache = array();
// $hentry     = array();

//  # Connect to the database.
//  $cf::dbh = DBI->connect($cf::DBDSN, $cf::DBUSER, $cf::DBPASS,
//                         { RaiseError => 1,
//                           PrintError => 0,
//                           AutoCommit => 1,
//                           LongReadLen => 128000,
//                           LongTruncOk => 0 });

// # $cf::dbh->do("SET character_set_client = 'cp850'");
// # $cf::dbh->do("SET SQL_MODE=''");
// ##############################################################################

//  our $compresscfg = CompressCfg->new($cf::COMPRESSCFG);

// require_once 'configurator.php';
// require_once('configurator.php');
require_once 'includes/configurator2.php';
$cnfid = new Configurator;
$compresscfg = $cnfid->open('includes/compress.cfg');
$compresscfg->parse();
$pck = array();
$pck = $compresscfg->getDirectives();
// print_r($compresscfg->getDirectives());
// die ('debug: termination.');

global $NLSOURCE;

include("db/db.php");

//   our $tmpdir = tempdir(CLEANUP => 1);
$tmpdir = tempnam("", "tmp");
if (is_file($tmpdir)) {
  unlink($tmpdir);
}
$tmp2dir = $actpath."/".basename($tmpdir);

if (is_dir($tmp2dir)) {
  // use existing path?
} else {
  mkdir($tmp2dir, 0700);
  if (is_dir($tmp2dir)) {
    // ok
  } else {
    logfile("E","Tempdir ".$tmp2dir." couldn't be created.");
    die("Tempdir couldn't be created.");
  }
}
// echo $actpath."\r\n";
// echo $tmp2dir."\r\n";
logfile('D',"Using temp dir: ".$tmp2dir);

#  empty_database(); # debug

//  our ($nodes, $linecache);
//  $nodes = read_nodes();
//  $linecache = read_linedata();

// $nodes = array();
// $linecache = array();


// 
$testsource = $NLSOURCE;

if (is_dir($testsource)) { 

  switch($rmarg) {
    case '0':
      // working on workqueue
      logfile('L',"Execute Workqueue");
      logfile('D',"Execute Workqueue");
      import_from_wq();
      break;

    case '1':
      //   regular directory scan
      logfile('L',"Scanning ".$NLSOURCE);
      logfile('D',"Scanning ".$NLSOURCE);
      import_subdir(str_replace(chr(92),chr(47),$NLSOURCE));
      break;

    case '2':
      // search possible nodelists and write path and filenames to workqueue, sord=99999
      logfile('L',"Scanning ".$NLSOURCE." to workqueue");
      logfile('D',"Scanning ".$NLSOURCE." to workqueue");
      import_subdir(str_replace(chr(92),chr(47),$NLSOURCE));
      break;

    case '3':        
      // ndl2db 3 path/file
      // add path/file to workqueue
      logfile('L',"Add ".$raddndl." to workqueue");
      logfile('D',"Add ".$raddndl." to workqueue");
      add_to_wq($raddndl);
      break;

    case '4':        
      // ndl2db 4 path/file
      // import single path/file w/o workqueue
      logfile('L',"Import ".$raddndl." to DB");
      logfile('D',"Import ".$raddndl." to DB");
      import_file($raddndl);
      break;

    default:
      // working on workqueue
      logfile('L',"Execute Workqueue");
      logfile('D',"Execute Workqueue");
      import_from_wq();
      break;
  }

} else {
  logfile('L',"ERROR: Exec terminated. ".$NLSOURCE." not available.");
  logfile('D',"ERROR: Exec terminated. ".$NLSOURCE." not available.");
  logfile('E',"ERROR: Exec terminated. ".$NLSOURCE." not available.");  
}
  
// $nodes = array();
// $linecache = array();

//$list = update_stat();
//update_history($list);

//   $cf::dbh->disconnect;
$db->sql_close();

// remove temp dir
if (is_dir($tmp2dir)) {
  // remove temp path
  chdir($actpath);
  full_rmdir(basename($tmpdir));
}

// close logfiles
if ( (file_exists($stopflagfileg)) || (file_exists($stopflagfiles)) )  {
  if (file_exists($stopflagfileg)) {
    logfile('D', "execution terminated by stopfile: '".$stopflagfileg."'");
  } else {
    logfile('D', "execution terminated by stopfile: '".$stopflagfiles."'");
  }
}
logfile('Q');
fclose ($tsfp);
unlink($sessionfile.".run");
if (file_exists($sessionfile.".end")) {
  unlink($sessionfile.".end");
}
  
//exit 0;

?>
